% eigen_function(TM,M)
% x: input vector, 2(M+1)*1, the first (M+1) elements are the steady state
% queue length distribution, the last (M+1) elements are the QLA power
% control law h(q)
% return pi( I - P(H) )


function [ave_power] = ave_power(TV,setting)

M = setting.M;
W = setting.W;
Ts = setting.dt;
lambda = setting.lambda;
mu = setting.mu;
index = get_index_of_TP(M,mu);

[ps, P] = get_q_distr(TV, setting);

temp = [0:M];
A = 2.^( temp / W / Ts ) - 1;

ave_power = ave_power_A(ps,P,lambda,M,A,index);
