function index = get_index_of_TP(M,mu)


temp = zeros( 1, M + 1);
%%% # of non-zero elements in each row of the transition probability matrix
temp = [ mu : mu + M ] + 1;  
temp(end - mu + 1 : end ) = M + 1;

% We put all the non zero elements of the transition probability matrix in
% a row vector X.
%
% index is a (M+1) by 3 matrix.
% index(i,1) represents the index of the element of the ith row, first 
% column of the transition probability matrix in the parameter X   
% index(i,2) represents the index of the ith row, last non-zero element
% of the transition probability matrix in the parameter X   
% index(i,3) represents the # of non-zero elements in the ith row of the 
% transition probability matrix   
%
% For example, X = [p00, p01, p02, p03, p04, ...
%                   p10, p11, p12, p12, p14, p15, ...
%                   p20, p21, p22, p22, p24, p25, p26, ...
%                   p30, p31, p32, p32, p34, p35, p36, p37, ...
%                   p40, p41, p42, p42, p44, p45, p46, p47, ...
%                   p50, p51, p52, p52, p54, p55, p56, p57, ...
%                   p60, p61, p62, p62, p64, p65, p66, p67, ...
%                   p70, p71, p72, p72, p74, p75, p76, p77 ]
%
% index = [ 1, 5, 5;
%                6, 11,6;
%                12,18,7;
%                19,26,8;
%                27,34,8;
%                35,42,8;
%                43,50,8;
%                51,58,8; ]

index = zeros( M+1,3);
index(:,2) = cumsum(temp).';
index(:,3) = temp.';
index([2:end],1)= index([1:end-1],2)+1;
index(1,1) = 1;

