function [gpower,ppower] = get_power_control_g_q_prac(A, TV, setting)

% A starting from q = 0, so delete the first item
%A(1) = [];

M = setting.M;
mu = setting.mu;
index = get_index_of_TP(M,mu);

%%% Power Control Law
g_points_vector = get_g_points_vector(index, TV, setting);
g_points_vector( g_points_vector == Inf ) = -10;
g_max = max( g_points_vector);
g_points_vector( g_points_vector == -10 ) = Inf;
g_TP = get_TP_matrix_from_vector(g_points_vector,M,index);
ppower = cell(M+1,1);
gpower = cell(M+1,1);
N = 10;  % samples per segments

for loop_q = 0:M
    ppower{loop_q+1} = zeros(1, index(loop_q+1,3) * N );
    gpower{loop_q+1} = zeros(1, index(loop_q+1,3) * N );
    
    for loop_g = index( loop_q+1, 3) : -1 : 1
        
        point_begin = g_TP(loop_q+1, loop_g);
        if loop_g == 1
            point_end = g_max * 2;
        else
            point_end = g_TP(loop_q+1, loop_g - 1);
        end
        current_index = (1:N) + N*( index( loop_q+1, 3)-loop_g );        
        
        if point_begin == Inf
            gpower{loop_q+1}( current_index ) = -10;
            ppower{loop_q+1}( current_index ) = -10;
        else    % point_begin ~= Inf
            if ( point_end > point_begin )
                if ( point_end == Inf )
                    point_end = g_max * 1.99;
                end
                k = [ point_begin : (point_end-point_begin)/N: point_end ] + 1e-100 * ( point_begin == 0);
                if length(k) > N
                    k(N+1:end)=[];
                end
            else % point_end <= point_begin
                k = ones(1,N) * point_begin + 1e-100 * ( point_begin == 0);
            end
            gpower{loop_q+1}( current_index ) = k;
            try
                ppower{loop_q+1}( current_index ) = A( index(loop_q+1,3) - loop_g + 1 ) ./  k;
            catch
                k
            end
        end
    end % end of loop_g
    gpower{loop_q+1}( gpower{loop_q+1} == -10 ) = [];
    ppower{loop_q+1}( ppower{loop_q+1} == -10 ) = [];
end % end of loop_q


for loop_q = 0:M
    len = length( ppower{loop_q+1} );
    index = find( gpower{loop_q+1}( 1 : len-1) == gpower{loop_q+1}( 2 : len ) );
    gpower{loop_q+1}( index ) = [];
    ppower{loop_q+1}( index ) = [];
end % end of loop_q