function piv = min_drop_prob_pi(optPara, setting)

M = setting.M;
lambda = setting.lambda;
Pbar = optPara.TargetPbar;
mu = setting.mu;
W = setting.W;
dt = setting.dt;

lb = 1e-10 * ones( M+1, 1);
ub = ones(M+1, 1);

Beq = 1;
Aeq = ones(1, M+1) ;

q = 0:1:M;
L = min( q+mu, M);  % vector L starts from L(0)
U = max( q-mu, 0);  % vector U starts from U(0)
AA = 2.^ ( q / W / dt ) - 1;  %vector A starts from A(0)
BB = AA(2:end) - AA(1:end-1);    
BB = [0,BB];   %  vector B starts from B(0)

bound = AA(2) / BB(2) / optPara.Pmax;
A = zeros( M-mu+1, M+1);
B = zeros( M-mu+1, 1);
for qi = 0:M-mu
    indexA = qi : M; 
    indexPi = qi : L(qi+1) - 1; 
    A( qi+1, indexA + 1) = CHCCDF( BB( L(indexA+1)-L(qi+1)+2 ) * bound,  lambda); %exp( - lambda * BB( L(indexA+1)-L(qi+1)+2 ) * bound );
    A( qi+1, indexPi + 1) = A( qi+1, indexPi + 1) - 1; 
    B( qi+1 ) = -1e-10;
end

piv = fmincon(@(piv) packet_drop_rate_pi(piv,setting),optPara.piv0,-A,B,Aeq,Beq,lb,ub, ...
              @(piv) ave_power_constraint_pi(piv,setting,optPara),setting.options);


